(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('rxjs'), require('rxjs/operators'), require('@angular/core'), require('@angular/common'), require('@angular/forms')) :
    typeof define === 'function' && define.amd ? define('@bravobit/bb-foundation/collections', ['exports', 'rxjs', 'rxjs/operators', '@angular/core', '@angular/common', '@angular/forms'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory((global.bravobit = global.bravobit || {}, global.bravobit["bb-foundation"] = global.bravobit["bb-foundation"] || {}, global.bravobit["bb-foundation"].collections = {}), global.rxjs, global.rxjs.operators, global.ng.core, global.ng.common, global.ng.forms));
})(this, (function (exports, rxjs, operators, i0, i1, forms) { 'use strict';

    function _interopNamespace(e) {
        if (e && e.__esModule) return e;
        var n = Object.create(null);
        if (e) {
            Object.keys(e).forEach(function (k) {
                if (k !== 'default') {
                    var d = Object.getOwnPropertyDescriptor(e, k);
                    Object.defineProperty(n, k, d.get ? d : {
                        enumerable: true,
                        get: function () { return e[k]; }
                    });
                }
            });
        }
        n["default"] = e;
        return Object.freeze(n);
    }

    var i0__namespace = /*#__PURE__*/_interopNamespace(i0);
    var i1__namespace = /*#__PURE__*/_interopNamespace(i1);

    var CollectionProvider = /** @class */ (function () {
        function CollectionProvider() {
        }
        CollectionProvider.prototype.formatArrayToCollectionData = function (items) {
            var _a;
            var count = (_a = items === null || items === void 0 ? void 0 : items.length) !== null && _a !== void 0 ? _a : 1;
            return {
                pageSize: count,
                totalEntries: count,
                pageNumber: 1,
                totalPages: 1,
                data: items
            };
        };
        return CollectionProvider;
    }());

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise */
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b)
                if (Object.prototype.hasOwnProperty.call(b, p))
                    d[p] = b[p]; };
        return extendStatics(d, b);
    };
    function __extends(d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }
    var __assign = function () {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s)
                    if (Object.prototype.hasOwnProperty.call(s, p))
                        t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };
    function __rest(s, e) {
        var t = {};
        for (var p in s)
            if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
                t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }
    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
            r = Reflect.decorate(decorators, target, key, desc);
        else
            for (var i = decorators.length - 1; i >= 0; i--)
                if (d = decorators[i])
                    r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }
    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); };
    }
    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function")
            return Reflect.metadata(metadataKey, metadataValue);
    }
    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try {
                step(generator.next(value));
            }
            catch (e) {
                reject(e);
            } }
            function rejected(value) { try {
                step(generator["throw"](value));
            }
            catch (e) {
                reject(e);
            } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }
    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function () { if (t[0] & 1)
                throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function () { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f)
                throw new TypeError("Generator is already executing.");
            while (_)
                try {
                    if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done)
                        return t;
                    if (y = 0, t)
                        op = [op[0] & 2, t.value];
                    switch (op[0]) {
                        case 0:
                        case 1:
                            t = op;
                            break;
                        case 4:
                            _.label++;
                            return { value: op[1], done: false };
                        case 5:
                            _.label++;
                            y = op[1];
                            op = [0];
                            continue;
                        case 7:
                            op = _.ops.pop();
                            _.trys.pop();
                            continue;
                        default:
                            if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
                                _ = 0;
                                continue;
                            }
                            if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) {
                                _.label = op[1];
                                break;
                            }
                            if (op[0] === 6 && _.label < t[1]) {
                                _.label = t[1];
                                t = op;
                                break;
                            }
                            if (t && _.label < t[2]) {
                                _.label = t[2];
                                _.ops.push(op);
                                break;
                            }
                            if (t[2])
                                _.ops.pop();
                            _.trys.pop();
                            continue;
                    }
                    op = body.call(thisArg, _);
                }
                catch (e) {
                    op = [6, e];
                    y = 0;
                }
                finally {
                    f = t = 0;
                }
            if (op[0] & 5)
                throw op[1];
            return { value: op[0] ? op[1] : void 0, done: true };
        }
    }
    var __createBinding = Object.create ? (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        Object.defineProperty(o, k2, { enumerable: true, get: function () { return m[k]; } });
    }) : (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        o[k2] = m[k];
    });
    function __exportStar(m, o) {
        for (var p in m)
            if (p !== "default" && !Object.prototype.hasOwnProperty.call(o, p))
                __createBinding(o, m, p);
    }
    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m)
            return m.call(o);
        if (o && typeof o.length === "number")
            return {
                next: function () {
                    if (o && i >= o.length)
                        o = void 0;
                    return { value: o && o[i++], done: !o };
                }
            };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }
    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m)
            return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done)
                ar.push(r.value);
        }
        catch (error) {
            e = { error: error };
        }
        finally {
            try {
                if (r && !r.done && (m = i["return"]))
                    m.call(i);
            }
            finally {
                if (e)
                    throw e.error;
            }
        }
        return ar;
    }
    /** @deprecated */
    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }
    /** @deprecated */
    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++)
            s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    }
    function __spreadArray(to, from, pack) {
        if (pack || arguments.length === 2)
            for (var i = 0, l = from.length, ar; i < l; i++) {
                if (ar || !(i in from)) {
                    if (!ar)
                        ar = Array.prototype.slice.call(from, 0, i);
                    ar[i] = from[i];
                }
            }
        return to.concat(ar || Array.prototype.slice.call(from));
    }
    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }
    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n])
            i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try {
            step(g[n](v));
        }
        catch (e) {
            settle(q[0][3], e);
        } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length)
            resume(q[0][0], q[0][1]); }
    }
    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }
    function __asyncValues(o) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function (v) { resolve({ value: v, done: d }); }, reject); }
    }
    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) {
            Object.defineProperty(cooked, "raw", { value: raw });
        }
        else {
            cooked.raw = raw;
        }
        return cooked;
    }
    ;
    var __setModuleDefault = Object.create ? (function (o, v) {
        Object.defineProperty(o, "default", { enumerable: true, value: v });
    }) : function (o, v) {
        o["default"] = v;
    };
    function __importStar(mod) {
        if (mod && mod.__esModule)
            return mod;
        var result = {};
        if (mod != null)
            for (var k in mod)
                if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k))
                    __createBinding(result, mod, k);
        __setModuleDefault(result, mod);
        return result;
    }
    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }
    function __classPrivateFieldGet(receiver, state, kind, f) {
        if (kind === "a" && !f)
            throw new TypeError("Private accessor was defined without a getter");
        if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver))
            throw new TypeError("Cannot read private member from an object whose class did not declare it");
        return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
    }
    function __classPrivateFieldSet(receiver, state, value, kind, f) {
        if (kind === "m")
            throw new TypeError("Private method is not writable");
        if (kind === "a" && !f)
            throw new TypeError("Private accessor was defined without a setter");
        if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver))
            throw new TypeError("Cannot write private member to an object whose class did not declare it");
        return (kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value)), value;
    }

    var ApiCollectionProvider = /** @class */ (function (_super) {
        __extends(ApiCollectionProvider, _super);
        function ApiCollectionProvider(_endpoint, _httpClient) {
            var _this = _super.call(this) || this;
            _this._endpoint = _endpoint;
            _this._httpClient = _httpClient;
            // State.
            _this._extraParams = {};
            _this.getBackendFormat = function (request) {
                var _a, _b, _c, _d, _e, _f, _g;
                var params = {};
                params['page'] = (_a = request === null || request === void 0 ? void 0 : request.pageNumber) !== null && _a !== void 0 ? _a : 1;
                params['page_size'] = (_b = request === null || request === void 0 ? void 0 : request.pageSize) !== null && _b !== void 0 ? _b : 25;
                if (request === null || request === void 0 ? void 0 : request.sort) {
                    var sort = Array.isArray(request === null || request === void 0 ? void 0 : request.sort) ? request === null || request === void 0 ? void 0 : request.sort : [request === null || request === void 0 ? void 0 : request.sort];
                    var filteredSort = sort === null || sort === void 0 ? void 0 : sort.filter(function (item) { return !!(item === null || item === void 0 ? void 0 : item.name) && !!(item === null || item === void 0 ? void 0 : item.direction); });
                    params['sort'] = (_c = filteredSort === null || filteredSort === void 0 ? void 0 : filteredSort.map(function (item) { return item === null || item === void 0 ? void 0 : item.name; })) === null || _c === void 0 ? void 0 : _c.join(',');
                    params['sort_direction'] = (_d = filteredSort === null || filteredSort === void 0 ? void 0 : filteredSort.map(function (item) { return item === null || item === void 0 ? void 0 : item.direction; })) === null || _d === void 0 ? void 0 : _d.join(',');
                }
                if ((request === null || request === void 0 ? void 0 : request.query) && ((_e = request === null || request === void 0 ? void 0 : request.query) === null || _e === void 0 ? void 0 : _e.length) > 0 && (request === null || request === void 0 ? void 0 : request.queryFields) && ((_f = request === null || request === void 0 ? void 0 : request.queryFields) === null || _f === void 0 ? void 0 : _f.length) > 0) {
                    params['query'] = request === null || request === void 0 ? void 0 : request.query;
                    params['query_fields'] = (_g = request === null || request === void 0 ? void 0 : request.queryFields) === null || _g === void 0 ? void 0 : _g.join(',');
                }
                return params;
            };
            return _this;
        }
        ApiCollectionProvider.prototype.append = function (name, value) {
            this._extraParams[name] = rxjs.isObservable(value) ? value : rxjs.of(value);
            return this;
        };
        ApiCollectionProvider.prototype.transform = function (request) {
            var _this = this;
            var endpoint$ = rxjs.isObservable(this._endpoint) ? this._endpoint : rxjs.of(this._endpoint);
            var params = this.getBackendFormat(request);
            var extraParams$ = this.getExtraParams(this._extraParams);
            return rxjs.combineLatest([endpoint$, extraParams$]).pipe(operators.switchMap(function (_h) {
                var _j = __read(_h, 2), endpoint = _j[0], extraParams = _j[1];
                return _this._httpClient.get(endpoint, {
                    params: Object.assign(Object.assign({}, params), extraParams)
                });
            }), operators.map(function (response) { return _this.formatToCollectionData(response); }));
        };
        ApiCollectionProvider.prototype.getExtraParams = function (params) {
            var keys = Object.keys(params !== null && params !== void 0 ? params : {});
            if (keys.length <= 0) {
                return rxjs.of({});
            }
            var observables$ = keys.map(function (key) { return params === null || params === void 0 ? void 0 : params[key]; });
            return rxjs.combineLatest(observables$).pipe(operators.map(function (data) {
                return data.reduce(function (previous, current, index) {
                    var _h;
                    var key = keys === null || keys === void 0 ? void 0 : keys[index];
                    return Object.assign(Object.assign({}, previous), (_h = {}, _h[key] = current, _h));
                }, {});
            }));
        };
        ApiCollectionProvider.prototype.formatToCollectionData = function (response) {
            if (Array.isArray(response)) {
                return this.formatArrayToCollectionData(response);
            }
            return {
                pageSize: response === null || response === void 0 ? void 0 : response['page_size'],
                pageNumber: response === null || response === void 0 ? void 0 : response['page_number'],
                totalPages: response === null || response === void 0 ? void 0 : response['total_pages'],
                totalEntries: response === null || response === void 0 ? void 0 : response['total_entries'],
                data: response === null || response === void 0 ? void 0 : response['data']
            };
        };
        return ApiCollectionProvider;
    }(CollectionProvider));

    var LocalCollectionProvider = /** @class */ (function (_super) {
        __extends(LocalCollectionProvider, _super);
        function LocalCollectionProvider(_items) {
            var _this = _super.call(this) || this;
            _this._items = _items;
            return _this;
        }
        LocalCollectionProvider.prototype.transform = function (request) {
            var _this = this;
            var items$ = Array.isArray(this._items)
                ? rxjs.of(this._items)
                : this._items;
            return items$.pipe(operators.map(function (items) { return _this.formatArrayToCollectionData(items); }));
        };
        return LocalCollectionProvider;
    }(CollectionProvider));

    var BbCollectionsData = /** @class */ (function () {
        function BbCollectionsData() {
        }
        return BbCollectionsData;
    }());
    BbCollectionsData.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.11", ngImport: i0__namespace, type: BbCollectionsData, deps: [], target: i0__namespace.ɵɵFactoryTarget.Directive });
    BbCollectionsData.ɵdir = i0__namespace.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "12.2.11", type: BbCollectionsData, selector: "[bbCollectionsData]", ngImport: i0__namespace });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.11", ngImport: i0__namespace, type: BbCollectionsData, decorators: [{
                type: i0.Directive,
                args: [{
                        selector: '[bbCollectionsData]'
                    }]
            }] });
    var BbCollectionsEmpty = /** @class */ (function () {
        function BbCollectionsEmpty() {
        }
        return BbCollectionsEmpty;
    }());
    BbCollectionsEmpty.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.11", ngImport: i0__namespace, type: BbCollectionsEmpty, deps: [], target: i0__namespace.ɵɵFactoryTarget.Directive });
    BbCollectionsEmpty.ɵdir = i0__namespace.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "12.2.11", type: BbCollectionsEmpty, selector: "[bbCollectionsEmpty]", ngImport: i0__namespace });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.11", ngImport: i0__namespace, type: BbCollectionsEmpty, decorators: [{
                type: i0.Directive,
                args: [{
                        selector: '[bbCollectionsEmpty]'
                    }]
            }] });
    var BbCollectionsError = /** @class */ (function () {
        function BbCollectionsError() {
        }
        return BbCollectionsError;
    }());
    BbCollectionsError.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.11", ngImport: i0__namespace, type: BbCollectionsError, deps: [], target: i0__namespace.ɵɵFactoryTarget.Directive });
    BbCollectionsError.ɵdir = i0__namespace.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "12.2.11", type: BbCollectionsError, selector: "[bbCollectionsError]", ngImport: i0__namespace });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.11", ngImport: i0__namespace, type: BbCollectionsError, decorators: [{
                type: i0.Directive,
                args: [{
                        selector: '[bbCollectionsError]'
                    }]
            }] });
    var BbCollectionsInitial = /** @class */ (function () {
        function BbCollectionsInitial() {
        }
        return BbCollectionsInitial;
    }());
    BbCollectionsInitial.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.11", ngImport: i0__namespace, type: BbCollectionsInitial, deps: [], target: i0__namespace.ɵɵFactoryTarget.Directive });
    BbCollectionsInitial.ɵdir = i0__namespace.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "12.2.11", type: BbCollectionsInitial, selector: "[bbCollectionsInitial]", ngImport: i0__namespace });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.11", ngImport: i0__namespace, type: BbCollectionsInitial, decorators: [{
                type: i0.Directive,
                args: [{
                        selector: '[bbCollectionsInitial]'
                    }]
            }] });

    var BbCollectionsViewer = /** @class */ (function () {
        function BbCollectionsViewer() {
            // Inputs.
            this.collection = null;
        }
        return BbCollectionsViewer;
    }());
    BbCollectionsViewer.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.11", ngImport: i0__namespace, type: BbCollectionsViewer, deps: [], target: i0__namespace.ɵɵFactoryTarget.Component });
    BbCollectionsViewer.ɵcmp = i0__namespace.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.11", type: BbCollectionsViewer, selector: "[bb-collections-viewer]", inputs: { collection: "collection" }, host: { classAttribute: "bb-collections-viewer" }, queries: [{ propertyName: "dataTemplate", first: true, predicate: BbCollectionsData, descendants: true, read: i0.TemplateRef }, { propertyName: "emptyTemplate", first: true, predicate: BbCollectionsEmpty, descendants: true, read: i0.TemplateRef }, { propertyName: "errorTemplate", first: true, predicate: BbCollectionsError, descendants: true, read: i0.TemplateRef }, { propertyName: "initialTemplate", first: true, predicate: BbCollectionsInitial, descendants: true, read: i0.TemplateRef }], ngImport: i0__namespace, template: "<ng-container *ngIf=\"collection?.data$ | async as data\"\n              [ngSwitch]=\"data?.state\">\n    <ng-container *ngSwitchDefault>\n        <ng-container *ngTemplateOutlet=\"dataTemplate; context: {items: data?.response?.data}\"></ng-container>\n    </ng-container>\n    <ng-container *ngSwitchCase=\"'initial'\">\n        <ng-container *ngTemplateOutlet=\"initialTemplate\"></ng-container>\n    </ng-container>\n    <ng-container *ngSwitchCase=\"'empty'\">\n        <ng-container *ngTemplateOutlet=\"emptyTemplate; context: {query: data?.request?.query}\"></ng-container>\n    </ng-container>\n    <ng-container *ngSwitchCase=\"'error'\">\n        <ng-container *ngTemplateOutlet=\"errorTemplate; context: {error: data?.error}\"></ng-container>\n    </ng-container>\n</ng-container>\n", styles: [".bb-collections-viewer{display:block}\n"], directives: [{ type: i1__namespace.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { type: i1__namespace.NgSwitch, selector: "[ngSwitch]", inputs: ["ngSwitch"] }, { type: i1__namespace.NgSwitchDefault, selector: "[ngSwitchDefault]" }, { type: i1__namespace.NgTemplateOutlet, selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet"] }, { type: i1__namespace.NgSwitchCase, selector: "[ngSwitchCase]", inputs: ["ngSwitchCase"] }], pipes: { "async": i1__namespace.AsyncPipe }, changeDetection: i0__namespace.ChangeDetectionStrategy.OnPush, encapsulation: i0__namespace.ViewEncapsulation.None });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.11", ngImport: i0__namespace, type: BbCollectionsViewer, decorators: [{
                type: i0.Component,
                args: [{
                        selector: '[bb-collections-viewer]',
                        templateUrl: './collections-viewer.component.html',
                        styleUrls: ['./collections-viewer.component.scss'],
                        changeDetection: i0.ChangeDetectionStrategy.OnPush,
                        encapsulation: i0.ViewEncapsulation.None,
                        host: { 'class': 'bb-collections-viewer' },
                        preserveWhitespaces: false
                    }]
            }], propDecorators: { dataTemplate: [{
                    type: i0.ContentChild,
                    args: [BbCollectionsData, { read: i0.TemplateRef, static: false }]
                }], emptyTemplate: [{
                    type: i0.ContentChild,
                    args: [BbCollectionsEmpty, { read: i0.TemplateRef, static: false }]
                }], errorTemplate: [{
                    type: i0.ContentChild,
                    args: [BbCollectionsError, { read: i0.TemplateRef, static: false }]
                }], initialTemplate: [{
                    type: i0.ContentChild,
                    args: [BbCollectionsInitial, { read: i0.TemplateRef, static: false }]
                }], collection: [{
                    type: i0.Input
                }] } });

    var BbCollectionsPager = /** @class */ (function () {
        function BbCollectionsPager() {
            // Readonly data.
            this.maxAmountOfButtons = 5;
            this.cache$ = new rxjs.BehaviorSubject({});
            // State and subscriptions.
            this._label = null;
            this._collection = null;
            this._subscription = null;
        }
        Object.defineProperty(BbCollectionsPager.prototype, "label", {
            // Inputs.
            set: function (value) {
                this._label = value;
                this.cache$.next(this.cache$.getValue());
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(BbCollectionsPager.prototype, "collection", {
            set: function (collection) {
                this._collection = collection;
                this.observeCollectionChanges();
            },
            enumerable: false,
            configurable: true
        });
        BbCollectionsPager.prototype.ngOnInit = function () {
            var _this = this;
            this.data$ = this.cache$.pipe(operators.map(function (cache) {
                var _a, _b, _c, _d;
                var pageSize = (_a = cache === null || cache === void 0 ? void 0 : cache.pageSize) !== null && _a !== void 0 ? _a : 1;
                var pageNumber = (_b = cache === null || cache === void 0 ? void 0 : cache.pageNumber) !== null && _b !== void 0 ? _b : 1;
                var totalPages = (_c = cache === null || cache === void 0 ? void 0 : cache.totalPages) !== null && _c !== void 0 ? _c : 1;
                var totalEntries = (_d = cache === null || cache === void 0 ? void 0 : cache.totalEntries) !== null && _d !== void 0 ? _d : 0;
                var fromStart = Math.min((pageSize * (pageNumber - 1)) + 1, totalEntries);
                var fromEnd = Math.min((fromStart - 1) + pageSize, totalEntries);
                var pages = _this.filterActivePages(pageNumber, totalPages);
                var allowNext = pageNumber < totalPages;
                var allowPrevious = pageNumber > 1;
                return {
                    totalPages: totalPages,
                    pages: pages,
                    pageNumber: pageNumber,
                    allowNext: allowNext,
                    allowPrevious: allowPrevious,
                    label: _this.calculateLabel(fromStart, fromEnd, totalEntries)
                };
            }));
        };
        BbCollectionsPager.prototype.ngOnDestroy = function () {
            var _a;
            (_a = this._subscription) === null || _a === void 0 ? void 0 : _a.unsubscribe();
        };
        BbCollectionsPager.prototype.setPage = function (pageNumber, totalPages) {
            var _a, _b, _c, _d;
            // Calculate the new value.
            var newValue = Math.min(totalPages, Math.max(1, pageNumber));
            // Validate the value is actually different.
            var currentValue = (_b = (_a = this._collection) === null || _a === void 0 ? void 0 : _a.pageNumberControl) === null || _b === void 0 ? void 0 : _b.value;
            if (currentValue === newValue) {
                return;
            }
            (_d = (_c = this._collection) === null || _c === void 0 ? void 0 : _c.pageNumberControl) === null || _d === void 0 ? void 0 : _d.setValue(pageNumber);
        };
        BbCollectionsPager.prototype.observeCollectionChanges = function () {
            var _this = this;
            var _a, _b, _c, _d, _e;
            if (!this._collection) {
                return;
            }
            if (this._subscription) {
                (_a = this._subscription) === null || _a === void 0 ? void 0 : _a.unsubscribe();
            }
            var pageNumber = (_c = (_b = this._collection) === null || _b === void 0 ? void 0 : _b.pageNumberControl) === null || _c === void 0 ? void 0 : _c.value;
            var pageSize = (_e = (_d = this._collection) === null || _d === void 0 ? void 0 : _d.pageSizeControl) === null || _e === void 0 ? void 0 : _e.value;
            this.cache$.next({ pageNumber: pageNumber, pageSize: pageSize });
            this._subscription = this._collection.raw$.subscribe(function (data) {
                if (data) {
                    _this.cache$.next(data);
                }
            });
        };
        BbCollectionsPager.prototype.calculateLabel = function (start, end, total) {
            var _a;
            var startPoint = '[start]';
            var endPoint = '[end]';
            var totalPoint = '[total]';
            var label = (_a = this._label) !== null && _a !== void 0 ? _a : "Showing " + startPoint + " to " + endPoint + " of " + totalPoint + " results";
            return label
                .replace(startPoint, "<strong>" + start + "</strong>")
                .replace(endPoint, "<strong>" + end + "</strong>")
                .replace(totalPoint, "<strong>" + total + "</strong>");
        };
        BbCollectionsPager.prototype.calculatePages = function (pageNumber, totalPages) {
            var min = 1;
            var max = totalPages;
            var amount = Math.max(1, this.maxAmountOfButtons);
            var data = Array(amount)
                .fill(0)
                .map(function (_, index) { return pageNumber + (index - 1); });
            // Validate if the minimum value less than
            // the first value.
            if (data[0] < min) {
                return data.map(function (item) { return item + 1; });
            }
            // Calculate the difference with the max
            // if this value is higher than 0 we should minus it.
            var lastValueInArray = data[data.length - 1];
            var differenceWithMax = lastValueInArray - max;
            if (differenceWithMax > 0) {
                return data.map(function (item) { return item - differenceWithMax; });
            }
            // Just return the default data.
            return data;
        };
        BbCollectionsPager.prototype.filterActivePages = function (pageNumber, totalPages) {
            return this.calculatePages(pageNumber, totalPages)
                .filter(function (page) { return page > 0 && page <= totalPages; })
                .map(function (page) { return ({ page: page, active: pageNumber === page }); });
        };
        return BbCollectionsPager;
    }());
    BbCollectionsPager.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.11", ngImport: i0__namespace, type: BbCollectionsPager, deps: [], target: i0__namespace.ɵɵFactoryTarget.Component });
    BbCollectionsPager.ɵcmp = i0__namespace.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.11", type: BbCollectionsPager, selector: "bb-collections-pager", inputs: { label: "label", collection: "collection" }, host: { classAttribute: "bb-collections-pager" }, ngImport: i0__namespace, template: "<ng-container *ngIf=\"data$ | async as data\">\n    <div [innerHTML]=\"data?.label\"\n         class=\"bb-collections-pager-text\">\n    </div>\n\n    <div class=\"bb-collections-pager-container\">\n        <ul class=\"bb-collections-pager-list\">\n            <li class=\"bb-collections-pager-item\"\n                title=\"Previous page\">\n                <button [disabled]=\"!data?.allowPrevious\"\n                        (click)=\"setPage(data?.pageNumber - 1, data?.totalPages)\"\n                        class=\"bb-collections-pager-button arrow first\"\n                        type=\"button\">\n                    &#8592;\n                </button>\n            </li>\n            <li *ngFor=\"let item of data?.pages\"\n                [title]=\"'Page ' + item?.page\"\n                class=\"bb-collections-pager-item\">\n                <button [class.active]=\"item?.active\"\n                        (click)=\"setPage(item?.page, data?.totalPages)\"\n                        class=\"bb-collections-pager-button\"\n                        type=\"button\">\n                    {{ item?.page }}\n                </button>\n            </li>\n            <li class=\"bb-collections-pager-item\"\n                title=\"Next page\">\n                <button [disabled]=\"!data?.allowNext\"\n                        (click)=\"setPage(data?.pageNumber + 1, data?.totalPages)\"\n                        class=\"bb-collections-pager-button arrow last\"\n                        type=\"button\">\n                    &#8594;\n                </button>\n            </li>\n        </ul>\n    </div>\n</ng-container>\n", styles: [".bb-collections-pager{display:flex;align-items:center;flex-direction:column-reverse}.bb-collections-pager-text{display:block;margin-top:10px}.bb-collections-pager-text>strong{font-weight:500}.bb-collections-pager-container{width:100%;display:flex;overflow-x:auto;align-items:center;justify-content:center}.bb-collections-pager-list{display:flex;border-radius:6px;align-items:center;background-color:#fff;border:1px solid rgba(67,90,111,.3);box-shadow:#435a6f24 0 1px 2px inset}.bb-collections-pager-item:not(:last-child){border-right:1px solid #cccccc}.bb-collections-pager-button{height:34px;border:none;display:flex;padding:0 4px;min-width:40px;-webkit-appearance:none;-moz-appearance:none;appearance:none;min-height:34px;-webkit-user-select:none;-moz-user-select:none;-ms-user-select:none;user-select:none;align-items:center;justify-content:center;background-color:transparent}.bb-collections-pager-button:hover,.bb-collections-pager-button:focus,.bb-collections-pager-button:active,.bb-collections-pager-button.active{color:#1565c0;font-weight:500}.bb-collections-pager-button:hover,.bb-collections-pager-button:focus{background-color:#1565c00d}.bb-collections-pager-button:active,.bb-collections-pager-button.active{background-color:#1565c033}.bb-collections-pager-button:not(.arrow):hover,.bb-collections-pager-button:not(.arrow):focus{outline:1px solid rgba(21,101,192,.5)}.bb-collections-pager-button:not(.arrow):focus,.bb-collections-pager-button:not(.arrow):active{outline:1px solid #1565c0;box-shadow:#1565c066 0 0 0 3px}.bb-collections-pager-button:not(.arrow).active{outline:1px solid #1565c0}.bb-collections-pager-button.arrow{font-weight:500}.bb-collections-pager-button.arrow.first{border-top-left-radius:2px;border-bottom-left-radius:2px}.bb-collections-pager-button.arrow.last{border-top-right-radius:2px;border-bottom-right-radius:2px}.bb-collections-pager-button:disabled{color:#000;outline:none;opacity:.25;cursor:default;pointer-events:none;background-color:transparent}@media only screen and (min-width: 768px){.bb-collections-pager{flex-wrap:wrap;align-items:center;flex-direction:row;justify-content:space-between}.bb-collections-pager-text{margin-top:0}.bb-collections-pager-container{width:auto;overflow-x:unset}}\n"], directives: [{ type: i1__namespace.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { type: i1__namespace.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }], pipes: { "async": i1__namespace.AsyncPipe }, changeDetection: i0__namespace.ChangeDetectionStrategy.OnPush, encapsulation: i0__namespace.ViewEncapsulation.None });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.11", ngImport: i0__namespace, type: BbCollectionsPager, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'bb-collections-pager',
                        templateUrl: './collections-pager.component.html',
                        styleUrls: ['./collections-pager.component.scss'],
                        changeDetection: i0.ChangeDetectionStrategy.OnPush,
                        encapsulation: i0.ViewEncapsulation.None,
                        host: { 'class': 'bb-collections-pager' },
                        preserveWhitespaces: false
                    }]
            }], propDecorators: { label: [{
                    type: i0.Input
                }], collection: [{
                    type: i0.Input
                }] } });

    var Collection = /** @class */ (function () {
        function Collection(_provider, _initialValues) {
            if (_initialValues === void 0) { _initialValues = {}; }
            var _a, _b, _c, _d, _e;
            this._provider = _provider;
            this._initialValues = _initialValues;
            this.raw$ = new rxjs.BehaviorSubject(null);
            this.loading$ = new rxjs.BehaviorSubject(true);
            // State.
            this._formatter = null;
            this._refresh$ = new rxjs.BehaviorSubject(0);
            this._requestCache = null;
            this.controlToObservable = function (control) {
                return control.valueChanges.pipe(operators.distinctUntilChanged(), operators.startWith(control === null || control === void 0 ? void 0 : control.value));
            };
            this.queryControl = new forms.FormControl((_a = _initialValues === null || _initialValues === void 0 ? void 0 : _initialValues.query) !== null && _a !== void 0 ? _a : null);
            this.queryFieldsControl = new forms.FormControl((_b = _initialValues === null || _initialValues === void 0 ? void 0 : _initialValues.queryFields) !== null && _b !== void 0 ? _b : []);
            this.pageNumberControl = new forms.FormControl((_c = _initialValues === null || _initialValues === void 0 ? void 0 : _initialValues.pageNumber) !== null && _c !== void 0 ? _c : 1);
            this.pageSizeControl = new forms.FormControl((_d = _initialValues === null || _initialValues === void 0 ? void 0 : _initialValues.pageSize) !== null && _d !== void 0 ? _d : 25);
            this.sortControl = new forms.FormControl((_e = _initialValues === null || _initialValues === void 0 ? void 0 : _initialValues.sort) !== null && _e !== void 0 ? _e : null);
            this.data$ = this.getData();
        }
        Collection.prototype.refresh = function () {
            this._refresh$.next(0);
        };
        Collection.prototype.setFormatter = function (callback) {
            this._formatter = callback;
            return this;
        };
        Collection.prototype.getData = function () {
            var _this = this;
            var data$ = this.request.pipe(operators.tap(function () { return _this.loading$.next(true); }), operators.map(function (request) { return _this.validateRequest(request); }), operators.switchMap(function (request) {
                return _this._provider.transform(request).pipe(operators.tap(function (response) { return _this.cacheCollectionData(response); }), operators.map(function (response) { return ({ response: response, request: request, initial: false }); }), operators.catchError(function (error) { return rxjs.of({
                    error: error,
                    request: request,
                    response: null,
                    initial: false
                }); }));
            }), operators.startWith({ initial: true, response: null }));
            return rxjs.combineLatest([data$, this.loading$.asObservable()]).pipe(operators.map(function (_f) {
                var _g = __read(_f, 2), data = _g[0], loading = _g[1];
                var combined = Object.assign(Object.assign({}, data), { loading: loading });
                return Object.assign(Object.assign({}, combined), { response: _this.formatResponse(data === null || data === void 0 ? void 0 : data.response), state: _this.getState(combined) });
            }));
        };
        Collection.prototype.formatResponse = function (response) {
            var _this = this;
            var _a;
            if (!response) {
                return response;
            }
            var data = ((_a = response === null || response === void 0 ? void 0 : response.data) !== null && _a !== void 0 ? _a : []).map(function (item) {
                var _a;
                return !!_this._formatter ? (_a = _this._formatter) === null || _a === void 0 ? void 0 : _a.call(_this, item) : item;
            });
            return Object.assign(Object.assign({}, response), { data: data });
        };
        Collection.prototype.validateRequest = function (request) {
            var _a, _b, _c, _d;
            // We should reset the page number whenever we change the query or the page size.
            if (this._requestCache && request && (((_a = this._requestCache) === null || _a === void 0 ? void 0 : _a.query) !== (request === null || request === void 0 ? void 0 : request.query) || ((_b = this._requestCache) === null || _b === void 0 ? void 0 : _b.pageSize) !== (request === null || request === void 0 ? void 0 : request.pageSize))) {
                (_c = this.pageNumberControl) === null || _c === void 0 ? void 0 : _c.setValue(1, { emitEvent: false });
                request.pageNumber = (_d = this.pageNumberControl) === null || _d === void 0 ? void 0 : _d.value;
            }
            this._requestCache = Object.assign({}, request);
            return request;
        };
        Collection.prototype.getState = function (data) {
            var _a, _b, _c;
            if (!!(data === null || data === void 0 ? void 0 : data.error)) {
                return "error" /* Error */;
            }
            if (!!(data === null || data === void 0 ? void 0 : data.initial)) {
                return "initial" /* Initial */;
            }
            var count = (_c = (_b = (_a = data === null || data === void 0 ? void 0 : data.response) === null || _a === void 0 ? void 0 : _a.data) === null || _b === void 0 ? void 0 : _b.length) !== null && _c !== void 0 ? _c : 0;
            if (count <= 0) {
                return "empty" /* Empty */;
            }
            return "data" /* Data */;
        };
        Collection.prototype.cacheCollectionData = function (data) {
            this.raw$.next(data);
            this.loading$.next(false);
        };
        Object.defineProperty(Collection.prototype, "request", {
            get: function () {
                var pageNumber$ = this.controlToObservable(this.pageNumberControl);
                var pageSize$ = this.controlToObservable(this.pageSizeControl);
                var query$ = this.getQueryObservable();
                var queryFields$ = this.controlToObservable(this.queryFieldsControl);
                var sort$ = this.controlToObservable(this.sortControl);
                return rxjs.combineLatest([pageNumber$, pageSize$, query$, queryFields$, sort$, this._refresh$.asObservable()]).pipe(operators.map(function (_f) {
                    var _g = __read(_f, 5), pageNumber = _g[0], pageSize = _g[1], query = _g[2], queryFields = _g[3], sort = _g[4];
                    return ({
                        pageNumber: pageNumber,
                        pageSize: pageSize,
                        query: query,
                        queryFields: queryFields,
                        sort: sort
                    });
                }));
            },
            enumerable: false,
            configurable: true
        });
        Collection.prototype.getQueryObservable = function () {
            var _a;
            return this.queryControl.valueChanges.pipe(operators.debounceTime(400), operators.distinctUntilChanged(), operators.startWith((_a = this.queryControl) === null || _a === void 0 ? void 0 : _a.value));
        };
        return Collection;
    }());

    var CollectionsModule = /** @class */ (function () {
        function CollectionsModule() {
        }
        return CollectionsModule;
    }());
    CollectionsModule.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.11", ngImport: i0__namespace, type: CollectionsModule, deps: [], target: i0__namespace.ɵɵFactoryTarget.NgModule });
    CollectionsModule.ɵmod = i0__namespace.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.11", ngImport: i0__namespace, type: CollectionsModule, declarations: [
            // Components.
            BbCollectionsViewer,
            BbCollectionsPager,
            // Directives.
            BbCollectionsData,
            BbCollectionsEmpty,
            BbCollectionsError,
            BbCollectionsInitial
        ], imports: [i1.CommonModule], exports: [
            // Components.
            BbCollectionsViewer,
            BbCollectionsPager,
            // Directives.
            BbCollectionsData,
            BbCollectionsEmpty,
            BbCollectionsError,
            BbCollectionsInitial
        ] });
    CollectionsModule.ɵinj = i0__namespace.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.11", ngImport: i0__namespace, type: CollectionsModule, imports: [[i1.CommonModule]] });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.11", ngImport: i0__namespace, type: CollectionsModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        imports: [i1.CommonModule],
                        declarations: [
                            // Components.
                            BbCollectionsViewer,
                            BbCollectionsPager,
                            // Directives.
                            BbCollectionsData,
                            BbCollectionsEmpty,
                            BbCollectionsError,
                            BbCollectionsInitial
                        ],
                        exports: [
                            // Components.
                            BbCollectionsViewer,
                            BbCollectionsPager,
                            // Directives.
                            BbCollectionsData,
                            BbCollectionsEmpty,
                            BbCollectionsError,
                            BbCollectionsInitial
                        ]
                    }]
            }] });

    /**
     * Generated bundle index. Do not edit.
     */

    exports.ApiCollectionProvider = ApiCollectionProvider;
    exports.BbCollectionsData = BbCollectionsData;
    exports.BbCollectionsEmpty = BbCollectionsEmpty;
    exports.BbCollectionsError = BbCollectionsError;
    exports.BbCollectionsInitial = BbCollectionsInitial;
    exports.BbCollectionsPager = BbCollectionsPager;
    exports.BbCollectionsViewer = BbCollectionsViewer;
    exports.Collection = Collection;
    exports.CollectionProvider = CollectionProvider;
    exports.CollectionsModule = CollectionsModule;
    exports.LocalCollectionProvider = LocalCollectionProvider;

    Object.defineProperty(exports, '__esModule', { value: true });

}));
//# sourceMappingURL=bravobit-bb-foundation-collections.umd.js.map
